*Example to solve the bubble point problem**********************************************************
*The composition in the liquid phase is known*******************************************************

*Peng Robinson**************************************************************************************
*Compound ID****************************************************************************************
$onecho > PengRobinsonID.txt
ID1 3
ID2 4
ID3 5
ID4 8
ID5 7
$offecho
*Interaction parameter******************************************************************************
$onecho > PengRobinsonaij.txt
a12 -0.0078
a13  0.0033
a14  0.0111
a15  0.0267
a23 -0.0004
a24  0.0005043
a25  0.00067951
a34  0.00021669
a35  0.0174
a45  0.06
$offecho

$funclibin PengRobinson PengRobinson.dll
function f1_liq  /PengRobinson.f1_liq/;
function f2_liq  /PengRobinson.f2_liq/;
function f3_liq  /PengRobinson.f3_liq/;
function f4_liq  /PengRobinson.f4_liq/;
function f5_liq  /PengRobinson.f5_liq/;
function f1_vap  /PengRobinson.f1_vap/;
function f2_vap  /PengRobinson.f2_vap/;
function f3_vap  /PengRobinson.f3_vap/;
function f4_vap  /PengRobinson.f4_vap/;
function f5_vap  /PengRobinson.f5_vap/;

sets
i      compound    /C3,iC4,nC4,iC5,nC5/
;
parameter
x(i) liquid phase mole fraction
/C3 0.05
iC4 0.15
nC4 0.25
iC5 0.2
nC5 0.35/
P  pressue  [bar] /8.27/
;
positive variable
T   temeprature  [K]
y(i) vapor phase mole fraction
;

equation
eq1,eq2,eq3,eq4,eq5  phase equilibrium equations
eq6
;

eq1.. f1_liq(T,P,x('C3'),x('iC4'),x('nC4'),x('iC5'),x('nC5')) =e= f1_vap(T,P,y('C3'),y('iC4'),y('nC4'),y('iC5'),y('nC5'));
eq2.. f2_liq(T,P,x('C3'),x('iC4'),x('nC4'),x('iC5'),x('nC5')) =e= f2_vap(T,P,y('C3'),y('iC4'),y('nC4'),y('iC5'),y('nC5'));
eq3.. f3_liq(T,P,x('C3'),x('iC4'),x('nC4'),x('iC5'),x('nC5')) =e= f3_vap(T,P,y('C3'),y('iC4'),y('nC4'),y('iC5'),y('nC5'));
eq4.. f4_liq(T,P,x('C3'),x('iC4'),x('nC4'),x('iC5'),x('nC5')) =e= f4_vap(T,P,y('C3'),y('iC4'),y('nC4'),y('iC5'),y('nC5'));
eq5.. f5_liq(T,P,x('C3'),x('iC4'),x('nC4'),x('iC5'),x('nC5')) =e= f5_vap(T,P,y('C3'),y('iC4'),y('nC4'),y('iC5'),y('nC5'));
eq6.. sum(i,y(i)) =e= 1;

T.l=354;
y.l(i)=x(i);

model test /all/
solve test using cns;



















